<?xml version="1.0" encoding="UTF-8"?>
<!--
 - Copyright 2005 Markus Moll
 -
 - This file is part of Refefree.
 -
 - This program is free software; you can redistribute it and/or modify
 - it under the terms of the GNU General Public License as published by
 - the Free Software Foundation; either version 2 of the License, or
 - (at your option) any later version.
 - 
 - This program is distributed in the hope that it will be useful,
 - but WITHOUT ANY WARRANTY; without even the implied warranty of
 - MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 - GNU General Public License for more details.
 - 
 - You should have received a copy of the GNU General Public License
 - along with this program; if not, write to the Free Software
 - Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<!-- xmlns="http://www.w3.org/1999/xhtml"-->
<xsl:output method="html"/>

<xsl:template match="/">
	<xsl:apply-templates />
</xsl:template>

<xsl:template match="serverstatus">
	<html>
		<head>
			<title>Scoreboard</title>
		</head>
		
		<body>
			<h1>Contest State</h1>
			<xsl:apply-templates select="contest-state" />
			<h1>Compile-time Configuration</h1>
			<xsl:apply-templates select="compiletime-config" />
			<h1>Run-time Configuration</h1>
			<xsl:apply-templates select="runtime-config" />
			<h1>Accounts</h1>
			<xsl:apply-templates select="accounts" />
			<h1>Connections</h1>
			<xsl:apply-templates select="connections" />
		</body>
	</html>
</xsl:template>

<xsl:template match="connections">
	<table border="1">
		<theader>
			<tr><th>Login</th><th>Name</th><th>Flags</th><th>Lag</th><th>Locks</th></tr>
		</theader>
		<tbody>
			<xsl:for-each select="established">
				<tr>
					<td><xsl:value-of select="login"/></td>
					<td><xsl:value-of select="name"/></td>
					<td><xsl:value-of select="flags"/></td>
					<td><xsl:value-of select="unanswered-heartbeats"/></td>
					<td><xsl:value-of select="locks"/></td>
				</tr>
			</xsl:for-each>
		</tbody>
	</table>
	<p>
		<xsl:choose>
		<xsl:when test="count(./new) = 0">No pending connections.</xsl:when>
		<xsl:when test="count(./new) = 1">One pending connection.</xsl:when>
		<xsl:otherwise><xsl:value-of select="count(./new)"/> pending connections.</xsl:otherwise>
		</xsl:choose>
	</p>
</xsl:template>

<xsl:template match="accounts">
	<table border="1">
		<theader>
			<tr><th>Login</th><th>Name</th><th>Flags</th></tr>
		</theader>
		<tbody>
			<xsl:for-each select="account">
				<tr>
					<td><xsl:value-of select="login"/></td>
					<td><xsl:value-of select="name"/></td>
					<td><xsl:value-of select="flags"/></td>
				</tr>
			</xsl:for-each>
		</tbody>
	</table>
</xsl:template>

<xsl:template match="languages">
	<xsl:for-each select="language">
	<tr>
		<td>language</td>
		<td><xsl:value-of select="id" /> - <xsl:value-of select="name" /></td>
	</tr>
	</xsl:for-each>
</xsl:template>

<xsl:template match="problems">
	<xsl:for-each select="problem">
	<tr>
		<td>problem</td>
		<td><xsl:value-of select="id" /> - <xsl:value-of select="name" /></td>
	</tr>
	</xsl:for-each>
</xsl:template>

<xsl:template match="*[count(child::*) = 0]">
	<tr>
		<td><xsl:value-of select="local-name(.)"/></td>
		<td><xsl:value-of select="."/></td>
	</tr>
</xsl:template>

<xsl:template match="*">
	<table border="1">
	<xsl:for-each select="./*">
		<xsl:apply-templates select="."/>
	</xsl:for-each>
	</table>
</xsl:template>

</xsl:stylesheet>
