/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 26.05.2005
 *
 */
package de.tudarmstadt.yajs;

import de.tudarmstadt.yajs.lib.JudgeClarificationAnswer;
import de.tudarmstadt.yajs.lib.PostedClarificationRequest;

/**
 * A pair of a posted clarification and the corresponding answer. The judge needs this information to display clarifications.
 * @author  markus
 */
public class ClarificationPair {
	/** The request part */
	protected PostedClarificationRequest request;
	
	/** The answer part */
	protected JudgeClarificationAnswer answer;
	
	/** Constructor. Builds a pair from a request and an answer. */
	public ClarificationPair(PostedClarificationRequest request, JudgeClarificationAnswer answer) {
		this.request = request;
		this.answer = answer;
	}
	
	/**
	 * Setter method for the answer.
	 * @param answer  The answer to set.
	 * @uml.property  name="answer"
	 */
	public void setAnswer(JudgeClarificationAnswer answer) {
		this.answer = answer;
	}
	/**
	 * Setter method for the request.
	 * @param request  The request to set.
	 * @uml.property  name="request"
	 */
	public void setRequest(PostedClarificationRequest request) {
		this.request = request;
	}
	/**
	 * Getter method for the answer.
	 * @return  Returns the answer.
	 * @uml.property  name="answer"
	 */
	public JudgeClarificationAnswer getAnswer() {
		return answer;
	}
	/**
	 * Getter method for the request.
	 * @return  Returns the request.
	 * @uml.property  name="request"
	 */
	public PostedClarificationRequest getRequest() {
		return request;
	}
}
