package de.tudarmstadt.yajs;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.LineNumberReader;

import de.tudarmstadt.yajs.lib.ContestInfo;
/**
*/
import de.tudarmstadt.yajs.lib.Language;


/**
 * @author O, Hung Lun
 * @date 11.01.2007
 */
public class Dcc32Utility {

	/**
	 * if the first 2 lines contain Borland Delphi and Borland Software Corporation respectively, 
	 * then filter, else return the original file.
	 * 
	 * @param  File  an output file of the native component.
	 * @return   File the output file without the first 3 lines of compiler information.   
	 * @see         
	 */
	public  static File compilerInfoFilter(File file){
	
	String ln1="Borland Delphi";
	String ln2="Borland Software Corporation";
	
	try {   File outputFile=File.createTempFile("dcc32", "out");
	        BufferedWriter out = new BufferedWriter(new FileWriter(outputFile));
	        LineNumberReader rd= new LineNumberReader(new FileReader(file));
	        if(rd.readLine().contains(ln1))
				if(rd.readLine().contains(ln2))
				{ rd.readLine();
			     out.write(rd.readLine()+"\n");
			     String str;
			     str=rd.readLine();
			     while(str!=null)
			    	 {
			    	 out.write(str+"\n");
			    	 str=rd.readLine();
			    	 }
		        }  
	        out.close();
	        return outputFile;
	     }catch (IOException e) {
	 }
	
	return file;
	}
/**
 * @param  ContestInfo the DelphiCompilerName in ContestInfo is particularly of interest here.
 * @return      Boolean true if dcc32 is the Delphi compiler name, else false.
 * @see         ContestInfo
 */
public static boolean isDCC32(Language language) {
	return language.getCompiler().getName().equalsIgnoreCase("DCC32");
}
}
