/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on Jan 8, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.gui;

import de.tudarmstadt.lang.*;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyVetoException;
import java.io.File;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JTextField;
/**
 * A FileSelector component. Groups a text-field (actually used as a label <b>REFACTOR</b>?) and a "select file" button. A constrained property change event will be fired when a file is selected.
 * @author  markus
 */
public class FileSelector extends JPanel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6188175104305563557L;

	/** The "select file" button. */
	private JButton button;
	/** The currently selected file. */
	private File file;


	
	/** Constructor. Sets up a FileSelector showing the <code>label</code> text on the button. */
	public FileSelector(String label)
	{
	
		
		
		button = new JButton(label);
				
		button.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));
				
				if(fc.showOpenDialog(FileSelector.this) != JFileChooser.APPROVE_OPTION) return;
				File old = file;
				file = fc.getSelectedFile();
			
				if(!file.equals(old))
				{
					try {
						fireVetoableChange(Lang.getString("file"), old, file);
					} catch (PropertyVetoException e) {
						file = null;
							
					}
				}
			}
		});
		
		setLayout(new GridLayout(1,1));
		add(button);
	
	}


	/** Constructor. Calls FileSelector("select"). */
	public FileSelector()
	{
		this("select");
	}
	
	/**
	 * Getter for the currently selected file. 
	 * @return  Returns the file that has been selected, <code>null</code> if there is none.
	 * @uml.property  name="file"
	 */
	public File getFile()
	{
		return file;
	}
	/**
	 * Setter for the currently selected file. 
	 * Sets the file, <code>null</code> if there is none.
	 * @uml.property  name="file"
	 */
	public void setFile(File file){
		this.file=file;
		
	}

	/**
	 * @param  
	 * @return      
	 * @see         
	 */
	public void setText(String string) {
		button.setText(string);
		
	}
	
	
}
