/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 28.04.2005
 *
 */
package de.tudarmstadt.yajs.gui;

/** Layout interface for MyTableModel.
 * This defines the number of columns in the table and their representations. 
 * <b>TODO:</b> Table column widths should go here (I learnt they are 'given by example').
 * @author markus
 *
 */
public interface MyTableItemLayout {

	/** Defines the number of columns in the table.
	 * @return The number of columns.
	 */
	int getColumnCount();

	/** Defines the title (name) of column <code>col</code>.
	 * @param col The number of the column, a zero-based index.
	 * @return Returns a string giving the title for the column <code>col</code>.
	 */
	String getColumnName(int col);

	/** Get the representation of object <code>item</code> for column <code>col</code>.
	 * @param item The item that is to be displayed.
	 * @param col The column for which a representation is needed.
	 * @return Returns an object giving the representation (likely to be a String) for <code>item</code>.
	 */
	Object getValue(Object item, int col);

}
