/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 21.04.2005
 *
 */
package de.tudarmstadt.yajs.gui;


/**
 * A simple predicate.
 * @author  markus
 */
public interface Predicate {
	
	/** Test whether the predicate contains element.
	 * This is the characteristic function of the predicate.
	 * @param element The element to test.
	 * @return Returns true if element is contained in this predicate, false otherwise.
	 */
	boolean contains(Object element);

	/** A predicate that is always true. 
	 */
	static Predicate alwaysTrue = new Predicate() {
		public boolean contains(Object element) {	return true; }
	};
	
	/** A predicate that is always false. 
	 */
	static Predicate alwaysFalse = new Predicate() {
		public boolean contains(Object element) {	return false; }
	};
}
