/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 13.04.2005
 *
 */
package de.tudarmstadt.yajs.gui;

/**
 * A verdict. <b>REFACTOR</b> not needed any more.
 * @author  markus
 */
public class Verdict {

	private int verdict;
	private String rationale;

	/**
	 * @param verdict
	 * @param rationale
	 */
	public Verdict(int verdict, String rationale) {
		this.verdict = verdict;
		this.rationale = new String(rationale);
	}

	/**
	 * @return  Returns the rationale.
	 * @uml.property  name="rationale"
	 */
	public String getRationale() {
		return rationale;
	}
	/**
	 * @return  Returns the verdict.
	 * @uml.property  name="verdict"
	 */
	public int getVerdict() {
		return verdict;
	}
	
	public static final int DONTJUDGE = 0;
	public static final int ACCEPTED = 1;
	public static final int REJECTED = 2;

}
