/**
 * 
 */
package de.tudarmstadt.yajs.gui.contestant;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyVetoException;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JTextField;

import de.tudarmstadt.lang.Lang;
import de.tudarmstadt.yajs.gui.FileSelector;

/**
 * @author O, Hung Lun
 * @date 20.03.2007
 */
public class EditorButton extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7023986212073614785L;
	/**
	 * 
	 */

	/** The text field in which the filename is displayed. */
	private JTextField textfield;
	/** The "select file" button. */
	private JButton button;
	/** The currently selected file. */
	private File file;
	
	/** Constructor. Sets up a FileSelector showing the <code>label</code> text on the button. */
	public EditorButton(String label)
	{
		textfield = new JTextField();
		textfield.setEditable(false);
		
		button = new JButton(label);
				
//		button.addActionListener(new ActionListener(){
//			public void actionPerformed(ActionEvent arg0) {
//				JFileChooser fc = new JFileChooser(System.getProperty("user.dir"));
//				
//				if(fc.showOpenDialog(EditorButton.this) != JFileChooser.APPROVE_OPTION) return;
//				File old = file;
//				file = fc.getSelectedFile();
//				textfield.setText(file.getName());
//				if(!file.equals(old))
//				{
//					try {
//						fireVetoableChange(Lang.getString("file"), old, file);
//					} catch (PropertyVetoException e) {
//						file = null;
//						textfield.setText("");			
//					}
//				}
//			}
//		});
		
		setLayout(new GridBagLayout());
		{
			GridBagConstraints constraints = new GridBagConstraints();
		
			constraints.weightx = 1;
			constraints.fill = GridBagConstraints.BOTH;
			constraints.gridx = 0;
			constraints.gridy = 0;
			add(textfield, constraints);
		}
		
		{
			GridBagConstraints constraints = new GridBagConstraints();
		
			constraints.weightx = 0;
			constraints.fill = GridBagConstraints.BOTH;
			constraints.gridx = 1;
			constraints.gridy = 0;
			add(button, constraints);
		}
	}

	/** Constructor. Calls FileSelector("select"). */
	public EditorButton()
	{
		this("select");
	}
	
	/**
	 * Getter for the currently selected file. 
	 * @return  Returns the file that has been selected, <code>null</code> if there is none.
	 * @uml.property  name="file"
	 */
	public File getFile()
	{
		return file;
	}
	/**
	 * Setter for the currently selected file. 
	 * Sets the file, <code>null</code> if there is none.
	 * @uml.property  name="file"
	 */
	public void setFile(File file){
		this.file=file;
		if (file!=null)
		this.textfield.setText(file.getName());
		else this.textfield.setText("");
	}
	
	public void setTextFieldText(String text){
		textfield.setText(text);
		
	}
	/**
	 * @param  
	 * @return      
	 * @see         
	 */
	public void setText(String string) {
		button.setText(string);
		
	}
	public void addButtonListener(ActionListener ls){
		button.addActionListener(ls);
		
	}


	
}
