package de.tudarmstadt.yajs.gui.contestant.events;

import java.io.File;
import java.util.EventObject;

import de.tudarmstadt.yajs.gui.contestant.ProblemPanel;
import de.tudarmstadt.yajs.lib.Language;
import de.tudarmstadt.yajs.lib.Problem;
/**
 * @author  markus
 */

public class EditorEvent extends EventObject {

	/**
	 * 
	 */
	private static final long serialVersionUID = -16588285377761129L;
	protected Problem problem;
	protected Language language;
	protected ProblemPanel problemPanel;
	private File file;
	
	
	public EditorEvent(Object source, Problem problem, Language language, File file) {
		super(source);
		this.problem = problem;
		this.language = language;
		this.file=file;
		}
	
	
	/**
	 * Getter for the problem.
	 * @return  Returns the problem.
	 * @uml.property  name="problem"
	 */
	public Problem getProblem() {
		return problem;
	}
	
	/**
	 * Getter for the language.
	 * @return  Returns the language.
	 * @uml.property  name="language"
	 */
	public Language getLanguage() {
		return language;
	}
	/**
	 * Getter for the ProblemPanel.
	 * @return  Returns the ProblemPanel.
	 * @uml.property  name="ProblemPanel"
	 */
	public ProblemPanel getProblemPanel() {
		return problemPanel;
	}


	/**
	 * @param  
	 * @return      
	 * @see         
	 */
	public File getFile() {
		
		return file;
	}
}
