/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 01.06.2005
 *
 */
package de.tudarmstadt.yajs.gui.contestant.events;

import de.tudarmstadt.yajs.lib.Problem;
import java.io.File;
import java.util.EventObject;

/**
 * @author  markus
 */
public class FileSelectionEvent extends EventObject {
	private File selectedFile;
	private Problem problem;
	public FileSelectionEvent(Object source){
		super(source);
	}
	public FileSelectionEvent(Object source, File selectedFile, Problem problem) {
		super(source);
		this.selectedFile = selectedFile;
		this.problem = problem;
	}
	
	/**
	 * @return  the selectedFile
	 * @uml.property  name="selectedFile"
	 */
	public File getSelectedFile() {
		return selectedFile;
	}
	
	/**
	 * @return  the problem
	 * @uml.property  name="problem"
	 */
	public Problem getProblem() {
		return problem;
	}
}
