/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 29.05.2005
 *
 */
package de.tudarmstadt.yajs.gui.contestant.events;

import de.tudarmstadt.yajs.lib.Language;
import de.tudarmstadt.yajs.lib.Problem;
import java.io.File;
import java.util.EventObject;

/**
 * @author  markus
 */
public class ManualTestEvent extends EventObject {


	/**
	 * 
	 */
	private static final long serialVersionUID = 8640888030829806616L;
	protected Problem problem;
	protected Language language;
	protected File file;
	
	public ManualTestEvent(Object source, Problem problem, File file, Language language) {
		super(source);
		this.problem = problem;
		this.language = language;
		this.file = file;
	}
	
	/**
	 * Getter for the file.
	 * @return  Returns the file.
	 * @uml.property  name="file"
	 */
	public File getFile() {
		return file;
	}
	
	/**
	 * Getter for the problem.
	 * @return  Returns the problem.
	 * @uml.property  name="problem"
	 */
	public Problem getProblem() {
		return problem;
	}
	
	/**
	 * Getter for the language.
	 * @return  Returns the language.
	 * @uml.property  name="language"
	 */
	public Language getLanguage() {
		return language;
	}

}
