/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 26.05.2005
 *
 */
package de.tudarmstadt.yajs.gui.contestant.events;

import java.util.HashSet;
import java.util.Iterator;

/**
 * @author markus
 *
 */
public class RefetchEventGenerator {

	private HashSet listeners = new HashSet();
	
	public synchronized void registerListener(RefetchEventListener listener) {
		listeners.add(listener);
	}

	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#unregisterListener(java.util.EventListener)
	 */
	public synchronized void unregisterListener(RefetchEventListener listener) {
		listeners.remove(listener);
	}

	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#emitEvent(java.util.EventObject)
	 */
	public synchronized void emitRefetch(RefetchEvent event) {
		Iterator i = listeners.iterator();
		while(i.hasNext())
		{
			RefetchEventListener lis = (RefetchEventListener) i.next();
			lis.refetch(event);
		}
	}
}
