/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package de.tudarmstadt.yajs.gui.contestant.events;

import de.tudarmstadt.yajs.lib.Language;
import de.tudarmstadt.yajs.lib.Problem;
import java.io.File;
import java.util.EventObject;

/**
 * @author  tim
 */
public class SubmitEvent extends EventObject
{
//	private Submission submission;
	
	private Problem problem;
	private Language language;
	private File file;
	
	public SubmitEvent(Object src, Problem problem, Language language, File file)
	{
		super(src);
		this.problem = problem;
		this.language = language;
		this.file = file;
	}
	

	/**
	 * @return  Returns the file.
	 * @uml.property  name="file"
	 */
	public File getFile() {
		return file;
	}
	
	/**
	 * @return  Returns the language.
	 * @uml.property  name="language"
	 */
	public Language getLanguage() {
		return language;
	}
	
	/**
	 * @return  Returns the problem.
	 * @uml.property  name="problem"
	 */
	public Problem getProblem() {
		return problem;
	}
	
}
