/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 08.05.2005
 *
 */
package de.tudarmstadt.yajs.gui.judge.events;

import java.util.HashSet;
import java.util.Iterator;

/**
 * @author markus
 *
 */
public class ClarificationEventGenerator {

	private HashSet listeners = new HashSet();
		
	/**
	 * @param listener 
	 */
	public void registerListener(ClarificationEventListener listener) {
		listeners.add(listener);
	}

	/**
	 * @param listener
	 */
	public void unregisterListener(ClarificationEventListener listener) {
		listeners.remove(listener);
	}

	/** 
	 * @param e
	 */
	public void emitChanged(ClarificationEvent e) {
		Iterator i = listeners.iterator();
		while(i.hasNext())
		{
			ClarificationEventListener lis = (ClarificationEventListener) i.next();
			lis.clarificationChanged(e);
		}
	}

	/** 
	 * @param e
	 */
	public void emitUnchanged(ClarificationEvent e) {
		Iterator i = listeners.iterator();
		while(i.hasNext())
		{
			ClarificationEventListener lis = (ClarificationEventListener) i.next();
			lis.clarificationUnchanged(e);
		}
	}
	
	/** 
	 * @param e
	 */
	public void emitNew(ClarificationEvent e) {
		Iterator i = listeners.iterator();
		while(i.hasNext())
		{
			ClarificationEventListener lis = (ClarificationEventListener) i.next();
			lis.clarificationUnchanged(e);
		}
	}
	
}
