/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 06.05.2005
 *
 */
package de.tudarmstadt.yajs.gui.judge.events;

import java.util.HashSet;
import java.util.Iterator;

/**  
 * @author markus
 *
 */
public class RefreshScoreboardEventGenerator {

	private HashSet listeners = new HashSet();
	
	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#registerListener(java.util.EventListener)
	 */
	public synchronized void registerListener(RefreshScoreboardEventListener listener) {
		listeners.add(listener);
	}

	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#unregisterListener(java.util.EventListener)
	 */
	public synchronized void unregisterListener(RefreshScoreboardEventListener listener) {
		listeners.remove(listener);
	}

	/** Return a copy of the listener map.
	 * This allows us to asynchronously iterate over a copy, while 
	 * still being able to concurrently change the map of listeners.
	 * @return
	 */
	private synchronized HashSet getListenersCopy() {
		return new HashSet(listeners);
	}
	
	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#emitEvent(java.util.EventObject)
	 */
	public void emitRefresh(RefreshScoreboardEvent e) {
		Iterator i = getListenersCopy().iterator();
		while(i.hasNext())
		{
			RefreshScoreboardEventListener lis = (RefreshScoreboardEventListener) i.next();
			lis.refreshScoreboard(e);
		}
	}

}
