/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on Jun 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.gui.judge.events;

import java.util.HashSet;
import java.util.Iterator;

/**
 * @author nemesis
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class RefreshServerStatusEventGenerator {

	private HashSet listeners = new HashSet();
	
	/** Register a new listener. 
	 * @param listener The listener to register.
	 */
	public synchronized void registerListener(RefreshServerStatusEventListener listener) {
		listeners.add(listener);
	}

	/** Unregister a new listener. 
	 * @param listener The listener to unregister.
	 */
	public synchronized void unregisterListener(RefreshServerStatusEventListener listener) {
		listeners.remove(listener);
	}

	/** Return a copy of the listener map.
	 * This allows us to asynchronously iterate over a copy, while 
	 * still being able to concurrently change the map of listeners.
	 * @return
	 */
	private synchronized HashSet getListenersCopy() {
		return new HashSet(listeners);
	}
	
	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#emitEvent(java.util.EventObject)
	 */
	public void emitRefresh(RefreshServerStatusEvent e) {
		Iterator i = getListenersCopy().iterator();
		while(i.hasNext())
		{
			RefreshServerStatusEventListener lis = (RefreshServerStatusEventListener) i.next();
			lis.refreshServerStatus(e);
		}
	}

}
