/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 13.04.2005
 *
 */
package de.tudarmstadt.yajs.gui.judge.events;

import java.util.EventListener;
import java.util.EventObject;
import java.util.HashSet;
import java.util.Iterator;

import de.tudarmstadt.events.EventGenerator;

/**
 * @author markus
 *
 */
public class TogglePauseEventGenerator implements EventGenerator {

	private HashSet listeners;
	
	/**
	 * 
	 */
	public TogglePauseEventGenerator() {
		this.listeners = new HashSet();
	}
	
	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#registerListener(java.util.EventListener)
	 */
	public void registerListener(EventListener e) {
		TogglePauseEventListener le = (TogglePauseEventListener) e;
		listeners.add(le);
	}

	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#unregisterListener(java.util.EventListener)
	 */
	public void unregisterListener(EventListener e) {
		TogglePauseEventListener le = (TogglePauseEventListener) e;
		listeners.remove(le);		
	}

	/* (non-Javadoc)
	 * @see de.tudarmstadt.events.EventGenerator#emitEvent(java.util.EventObject)
	 */
	public void emitEvent(EventObject e) {
		TogglePauseEvent sse = (TogglePauseEvent) e;
		Iterator i = listeners.iterator();
		while(i.hasNext())
		{
			TogglePauseEventListener lis = (TogglePauseEventListener) i.next();
			lis.togglePause(sse);
		}
	}

}
