/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 24.05.2005
 *
 */
package de.tudarmstadt.yajs.lib;

/**
 * An answer to a clarification request.
 * @author  markus
 */
public class ClarificationAnswer {
	private long requestIndex;
	private ClarificationAnswerState state;
	private String answer;
	
	
	/**
	 * @param index
	 * @param problem
	 * @param notified
	 * @param answer
	 */
	public ClarificationAnswer(long requestIndex, ClarificationAnswerState state,
			String answer) {
		super();
		this.requestIndex = requestIndex;
		this.state = state;
		this.answer = answer;
	}
	
	
	/**
	 * @return  Returns the answer.
	 * @uml.property  name="answer"
	 */
	public String getAnswer() {
		return answer;
	}
	/**
	 * @return  Returns the index of the clarification request this answer refers to.
	 * @uml.property  name="requestIndex"
	 */
	public long getRequestIndex() {
		return requestIndex;
	}
	
	/**
	 * @return  Returns the state of the clarification.
	 * @uml.property  name="state"
	 */
	public ClarificationAnswerState getState() {
		return state;
	}
}
