/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 24.05.2005
 *
 */
package de.tudarmstadt.yajs.lib;

/**
 * The state of a clarification.
 * @author  markus
 */
public class ClarificationAnswerState {
	private String name;
	/** Constructor. */
	private ClarificationAnswerState(String name) {
		this.name = name;
	}
	/** Get a string representation. */
	public String toString() {
		return name;
	}
	/** The clarification is unanswered. */
	public static final ClarificationAnswerState UNANSWERED = new ClarificationAnswerState("unanswered");
	/** The clarification has been answered, the answer was only sent to the questioner. */
	public static final ClarificationAnswerState QUESTIONER = new ClarificationAnswerState("questioner");
	/** The clarification has been answered, the answer was sent to everyone. */
	public static final ClarificationAnswerState EVERYONE = new ClarificationAnswerState("everyone");
}
