/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 25.05.2005
 *
 */
package de.tudarmstadt.yajs.lib;

/**
 * Also known as clarification_reply. Contrary to the judge variant, the client also receives the corresponding problem id. Both ClarificationAnswers share enough information to justify a common superclass.
 * @author  markus
 */
public class ClientClarificationAnswer extends ClarificationAnswer {

	private Problem problem;
	
	/** The constructor.
	 * @param requestIndex The index of the clarification request this answer refers to.
	 * @param problem The problem it relates to.
	 * @param state The state of the clarification.
	 * @param answer The answer.
	 */
	public ClientClarificationAnswer(long requestIndex, Problem problem, ClarificationAnswerState state, String answer) {
		super(requestIndex, state, answer);
		this.problem = problem;
	}
	
	/**
	 * @return  Returns the problem.
	 * @uml.property  name="problem"
	 */
	public Problem getProblem() {
		return problem;
	}

	/**
	 * @return Returns whether this is a general clarification.
	 */
	public boolean isGeneralClarification() {
		return getProblem() == null;
	}
}
