/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 03.05.2005
 *
 */
package de.tudarmstadt.yajs.lib;

/**
 * A contest status. Contains the status (running, paused...), the elapsed time and the total duration of the contest.
 * @author  markus
 */
public class ContestStatus {
	private ContestStatusEnumeration status;
	private long elapsed;
	private long duration;
	
	/** Constructor. Initializes the fields with the given values. 
	 * @param status The contest status.
	 * @param elapsed The number of minutes elapsed.
	 * @param duration The duration of the contest.
	 */
	public ContestStatus(ContestStatusEnumeration status, long elapsed, long duration) {
		this.status = status;
		this.elapsed = elapsed;
		this.duration = duration;
	}
	
	/**
	 * Get the elapsed time.
	 * @return  Returns the elapsed time.
	 * @uml.property  name="elapsed"
	 */
	public long getElapsed() {
		return elapsed;
	}
	/**
	 * Get the status.
	 * @return  Returns the status (before, running, paused, after).
	 * @uml.property  name="status"
	 */
	public ContestStatusEnumeration getStatus() {
		return status;
	}
	/**
	 * Get the duration of the contest.
	 * @return  Returns the contest duration.
	 * @uml.property  name="duration"
	 */
	public long getDuration() {
		return duration;
	}
}
