/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on Dec 5, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.lib;
import javax.swing.JOptionPane;
/**
 * A programming language.
 * @author  markus
 */
public class Language {

	String id;
	String name;
	CCompiler compiler;
	String editor;
	CCompiler defaultCompiler;
	
	
	/** Constructor.
	 * Creates a language given by an id and a name.
	 * @param id The id of this language.
	 * @param name The name of this language.
	 * @param string2 
	 * @param string 
	 */
	public Language(String id, String name, CCompiler compiler, String editor) {
		super();
		this.id = id;
		this.name = name;
		this.compiler=compiler;
		this.editor=editor;
		if(name.equalsIgnoreCase("java"))defaultCompiler=new CCompiler("javac","javac"," -d");
		if(name.equalsIgnoreCase("c"))defaultCompiler=new CCompiler("gcc","gcc"," -x c -O2 -Wall -lm -o");
		if(name.equalsIgnoreCase("c++"))defaultCompiler=new CCompiler("g++","g++","-x c++ -O2 -Wall -lm -o");
		if(name.equalsIgnoreCase("delphi"))defaultCompiler=new CCompiler("fpc","fpc","-v0 -v0");
		
	}
	
	

	/** Get a string representation.
	 * @return Returns the name.
	 */
	public String toString()
	{
		return getName();
	}

	/**
	 * Get the name of this language.
	 * @return  Returns the name.
	 * @uml.property  name="name"
	 */
	public String getName()
	{
		return name;
	}
	
	/** Get the id of this language.
	 * @return Returns the id.
	 */
	public String getID() {
		return id;
	}
	
	/** Get the compiler of this language.
	 * @return Returns the compiler.
	 */
	public CCompiler getCompiler() {
		
		if (compiler.getName()==" "){
			System.err.print("Compiler name missing in configuration file\n");	
		}
		if (compiler.getPath()==" "){
			System.err.print("Compiler path missing in configuration file. Set to default compiler: "+defaultCompiler.getName()+"\n");	
			return defaultCompiler;
		}
		return compiler;
		
		
	}
	/** Get the editor of this language.
	 * @return Returns the editor.
	 */
	public String getEditor() {
		return editor;
	}

}
