/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 04.05.2005
 *
 */
package de.tudarmstadt.yajs.lib;

/**
 * This is a clarification that is already sent. It _is_ a clarification and therefore inherits from ClarificationRequest  (which only encapsulates the problem and the text). TODO maybe this (like the submission classes) should be subject to (massive?) refactoring.
 * @author  markus
 */
public class PostedClarificationRequest extends ClarificationRequest {

	private long index;
	private long time;
	private String questioner;
	
	/** Constructor. Initializes fields with given values.
	 * @param problem The problem this clarification request relates to, <code>null</code> if it is a general clarification request.
	 * @param content The clarification request itself.
	 * @param index The index of this request.
	 * @param time The time after which the request was submitted.
	 * @param questioner The name of the user asking for clarification.
	 */
	public PostedClarificationRequest(Problem problem, String content, long index, long time, String questioner) {
		super(problem, content);
		this.index = index;
		this.time = time;
		this.questioner = questioner;
	}
	
	/**
	 * Get the index of this clarification.
	 * @return  Returns the index of this clarification.
	 * @uml.property  name="index"
	 */
	public long getIndex() {
		return index;
	}

	/**
	 * Get the questioner.
	 * @return  Returns the questioner.
	 * @uml.property  name="questioner"
	 */
	public String getQuestioner() {
		return questioner;
	}
	
	/**
	 * Get the time after which the clarification was submitted.
	 * @return  Returns the time when this clarification was submitted.
	 * @uml.property  name="time"
	 */
	public long getTime() {
		return time;
	}
}
