/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on Dec 5, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.lib;


/**
 * A problem. A problem is given by an id (typically some sort of enumeration, like 'A', 'B', ... or '1', '2', ...) and a title.
 * @author  markus
 */
public class Problem {
	/** The id of this problem. */
	private String id;
	/** The name of this problem. */
	private String name;
	/** The time limit of this problem. */
	private double tlimit ;
	
	/** Construct a problem given by <code>id</code> and <code>name</code>.
	 * @param id The id to use.
	 * @param name The name to use.
	 */
	public Problem(String id, String name)
	{
		this.id = id;
		this.name = name;
		this.tlimit=1000;
	}
	/** Construct a problem given by <code>id</code> and <code>name</code>.
	 * @param id The id to use.
	 * @param name The name to use.
	 */
	public Problem(String id, String name, double d)
	{
		this.id = id;
		this.name = name;
		this.tlimit=d;
	}
	
	/** Get a string representation.
	 * @return Returns <code>getID() + " - " + getName()</code>.
	 */
	public String toString()
	{
		return getID() + " - " + getName();
	}
	
	/** Get the id of this problem.
	 * @return Returns the id.
	 */
	public String getID() 
	{
		return id;
	}
	
	/**
	 * Get the name of this problem.
	 * @return  Returns the name.
	 * @uml.property  name="name"
	 */
	public String getName()
	{
		return name;
	}
	/**
	 * Get the time limit of this problem.
	 * @return  Returns the time limit.
	 * @uml.property  name="name"
	 */
	public double getTlimit()
	{
		return tlimit;
	}
}
