/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on Dec 5, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.lib;

/**
 * A result. 
 * @author  markus  TODO To change the template for this generated type comment go to  Window - Preferences - Java - Code Style - Code Templates
 */
public class Result {
	private long index;
	private Problem problem;
	private Language language;
	private long time;
	private Status status;
	private String reason;
	
	/** Constructor. Initializes internal fields with the given values.
	 * @param index The index of the corresponding submission.
	 * @param problem The problem of the corresponding submission.
	 * @param language The language of the corresponding submission.
	 * @param time The time after which the corresponding submission was received.
	 * @param status The status of the submission.
	 * @param reason The reason given by judges.
	 */
	public Result(long index, Problem problem, Language language, long time,
			Status status, String reason) {
		this.index = index;
		this.problem = problem;
		this.language = language;
		this.time = time;
		this.status = status;
		this.reason = reason;
	}
	/**
	 * Get the submission index.
	 * @return  Returns the index.
	 * @uml.property  name="index"
	 */
	public long getIndex() {
		return index;
	}
	/**
	 * Get the submission language.
	 * @return  Returns the language.
	 * @uml.property  name="language"
	 */
	public Language getLanguage() {
		return language;
	}
	/**
	 * Get the submission problem.
	 * @return  Returns the problem.
	 * @uml.property  name="problem"
	 */
	public Problem getProblem() {
		return problem;
	}
	/**
	 * Get the submission reason.
	 * @return  Returns the reason.
	 * @uml.property  name="reason"
	 */
	public String getReason() {
		return reason;
	}
	/**
	 * Get the submission status.
	 * @return  Returns the status.
	 * @uml.property  name="status"
	 */
	public Status getStatus() {
		return status;
	}
	/**
	 * Get the time after which the submission was received.
	 * @return  Returns the time.
	 * @uml.property  name="time"
	 */
	public long getTime() {
		return time;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object arg0) {
		/* FIXME refactor judgement classes... */
		Result other = (Result) arg0;
		return
			   getIndex() == other.getIndex()
			&& getLanguage().equals( other.getLanguage() )
			&& getProblem().equals( other.getProblem() )
			&& getReason().equals( other.getReason() )
			&& getStatus() == other.getStatus()
			&& getTime() == other.getTime();
	}
	
}
