/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 18.04.2005
 *
 */
package de.tudarmstadt.yajs.lib;

/**
 * A submission status. This class is an enumeration. When Java 5 is readily available, one might think about replacing it by an enum.
 * @author  markus
 */
public class Status {
	private String name;
	
	/** Constructs a status. 
	 * @param name Used as a description/name of this status.
	 */
	private Status(String name)
	{
		this.name = name;
	}
	
	/** The submission has not yet been judged. */
	public static final Status NEW = new Status("new");
	/** The submission had been judged, but the judgement was revoked later. */
	public static final Status UNJUDGED = new Status("unjudged");
	/** The submission was accepted (correct). */
	public static final Status ACCEPTED = new Status("accepted");
	/** The submission was rejected (wrong). */
	public static final Status REJECTED = new Status("rejected");
	/** The submission was ignored due to strange circumstances (see detailed reason). */
	public static final Status IGNORED = new Status("ignored");
	
	/** Get a string representation. 
	 * @return Returns the name of this status. 
	 */
	public String toString()
	{
		return name;
	}
}
