/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 25.05.2005
 *
 */
package de.tudarmstadt.yajs.lib.events;

import de.tudarmstadt.yajs.lib.ClientClarificationAnswer;
import java.util.EventObject;

/**
 * @author  markus
 */
public class ClientClarificationAnswerEvent extends EventObject {
	private boolean notified;
	private ClientClarificationAnswer answer;
	
	/**
	 * @param arg0
	 * @param answer
	 * @param notified
	 */
	public ClientClarificationAnswerEvent(Object arg0, boolean notified, ClientClarificationAnswer answer) {
		super(arg0);
		this.notified = notified;
		this.answer = answer;
	}

	/**
	 * @return  Returns the answer.
	 * @uml.property  name="answer"
	 */
	public ClientClarificationAnswer getAnswer() {
		return answer;
	}
	
	/**
	 * @return  Returns the notified.
	 * @uml.property  name="notified"
	 */
	public boolean isNotified() {
		return notified;
	}

}
