/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on Jun 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.lib.events;

import java.util.HashSet;
import java.util.Iterator;

/**
 * @author nemesis
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ServerStatusEventGenerator {
	
	private HashSet listeners = new HashSet();
	
	public synchronized void registerListener(ServerStatusEventListener listener) {
		listeners.add(listener);
	}

	public synchronized void unregisterListener(ServerStatusEventListener listener) {
		listeners.remove(listener);
	}

	/** Return a copy of the listeners set so we can iterate over it.
	 * @return A copy of the set listeners.
	 */
	private synchronized HashSet getListenersCopy() { 
		return new HashSet(listeners);
	}
	
	/**
	 * @param event
	 */
	public void emitServerStatusReceived(ServerStatusEvent event) {
		Iterator i = getListenersCopy().iterator();
		while(i.hasNext()) {
			ServerStatusEventListener lis = (ServerStatusEventListener) i.next();
			lis.serverStatusReceived(event);
		}
	}

}
