/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
package de.tudarmstadt.yajs.lib.fsm.actions;

import de.tudarmstadt.yajs.lib.ClientHelper;
import de.tudarmstadt.yajs.lib.ConnectionError;
import de.tudarmstadt.yajs.lib.MalformedMessage;
import de.tudarmstadt.yajs.lib.UnexpectedMessage;
import de.tudarmstadt.yajs.lib.fsm.ClientFSMHelper;

public interface ClientAction extends Action
{
	public static final String HELLO = "hello";
	public static final String HEARTBEAT_REQUEST = "heartbeat_request";
	public static final String HEARTBEAT_REPLY = "heartbeat_whoomp";
	public static final String LOGIN_WELCOME = "login_welcome";
	public static final String AUTOCONFIG = "login_autoconfig";
	public static final String LOGIN_REQUEST = "login_request";
	public static final String SCOREBOARD_REQUEST = "scoreboard_request";
	public static final String SCOREBOARD = "scoreboard";
	public static final String CLARIFICATION_REQUEST = "clarification_request";
	public static final String CLARIFICATION_LIST = "clarification_replies";
	public static final String CLARIFICATION_REPLY = "clarification_reply";
	public void perform(ClientHelper client, ClientFSMHelper fsm, String s) throws UnexpectedMessage, MalformedMessage, ConnectionError;
}
