/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 10.01.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.lib.fsm.actions;

import de.tudarmstadt.yajs.lib.CCompiler;
import de.tudarmstadt.yajs.lib.ClientHelper;
import de.tudarmstadt.yajs.lib.Language;
import de.tudarmstadt.yajs.lib.LanguageSet;
import de.tudarmstadt.yajs.lib.MalformedMessage;
import de.tudarmstadt.yajs.lib.Problem;
import de.tudarmstadt.yajs.lib.ProblemSet;
import de.tudarmstadt.yajs.lib.UnexpectedMessage;
import de.tudarmstadt.yajs.lib.fsm.ClientFSMHelper;

/**
 * @author  markus  TODO To change the template for this generated type comment go to  Window - Preferences - Java - Code Style - Code Templates
 */
public class CollectAutoConfig implements ClientAction {

	private ProblemSet problems;
	private LanguageSet languages;
	private boolean configReceived;
	
	
	public CollectAutoConfig()
	{
		this.problems = new ProblemSet();
		this.languages = new LanguageSet();
		this.configReceived = false;
	}

	/* (non-Javadoc)
	 * @see de.tudarmstadt.yajs.lib.fsm.actions.Action#perform(de.tudarmstadt.yajs.lib.ClientHelper, de.tudarmstadt.yajs.lib.fsm.FSMHelper, java.lang.String)
	 */
	public void perform(ClientHelper client, ClientFSMHelper fsm, String s)
			throws UnexpectedMessage, MalformedMessage {
		
		String[] lines = s.split("\n");		
		if(lines.length < 2) throw new MalformedMessage("Wrong number of lines: " + lines.length + " (expected at least 2)\n" + s);
		
		configReceived = true;
		
		String type = lines[1];
		if(type.equals("problem"))
		{
			
			if(lines.length != 5) throw new MalformedMessage("Wrong number of lines: " + lines.length + " (expected 5)\n" + s);
			String id = lines[2];
			String name = lines[3];
			double tlimit=Double.parseDouble(lines[4]);
			problems.add( new Problem(id, name,tlimit) );
		}
		else if(type.equals("language"))
		{
			if(lines.length != 8) throw new MalformedMessage("Wrong number of lines: " + lines.length + " (expected 8)\n" + s);
			String id = lines[2];
			String name = lines[3];
		
			String compiler=lines[4];
			String compilerPath=lines[5];
			String compilerOptions=lines[6];
			String editor=lines[7];
			
			//TODO pass the compiler option to languages.add as well.
			languages.add( new Language(id, name,new CCompiler(compiler,compilerPath,compilerOptions),editor) );
		} else if(type.equals("completed")) 
		{
			if(lines.length != 2) throw new MalformedMessage("Wrong number of lines: " + lines.length + " (expected 2)\n" + s);
			client.setAutoConfig(getProblems(),getLanguages());
		}
	}
	
	public boolean configWasReceived() {
		return configReceived;
	}
	
	/**
	 * @return  the problems
	 * @uml.property  name="problems"
	 */
	public ProblemSet getProblems() {
		return problems;
	}
	
	/**
	 * @return  the languages
	 * @uml.property  name="languages"
	 */
	public LanguageSet getLanguages() {
		return languages;
	}
}
