/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 14.03.2005
 *
 */
package de.tudarmstadt.yajs.lib.fsm.actions;

import de.tudarmstadt.yajs.lib.ConnectionError;
import de.tudarmstadt.yajs.lib.MalformedMessage;
import de.tudarmstadt.yajs.lib.UnexpectedMessage;
import de.tudarmstadt.yajs.lib.fsm.ClientFSMHelper;
import de.tudarmstadt.yajs.lib.judge.JudgeHelper;

/**
 * @author markus
 *
 */
public interface JudgeAction extends Action {
	public static final String QUERY_SUBMISSION_STATUSES = "submission_list";
	public static final String SUBMISSION_STATUS = "submission_notify";
	public static final String FETCH_SUBMISSION = "submission_fetch";
	public static final String SUBMISSION = "submission_source";
	public static final String TOGGLE_PAUSE = "pause_toggle";
	public static final String JUDGE = "submission_judge";
	public static final String LOCK_CLARIFICATION = "clarification_lock";
	public static final String CLARIFICATION_LOCKED = "clarification_locked";
	public static final String ANSWER_CLARIFICATION = "clarification_answer";
	public static final String CLARIFICATION_NOTIFY = "clarification_notify";
	public static final String CLARIFICATION_NOTIFY2 = "clarification_notify2";
	public static final String CLARIFICATION_LIST = "clarification_list";
	public static final String QUERY_SERVER_STATUS = "serverstatus_request";
	public static final String SERVER_STATUS_REPLY = "serverstatus_reply";
	public void perform(JudgeHelper judge, ClientFSMHelper fsm, String msg) throws UnexpectedMessage, MalformedMessage, ConnectionError;
}
