/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on Dec 5, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.lib.fsm.actions;

import de.tudarmstadt.yajs.lib.ClientHelper;
import de.tudarmstadt.yajs.lib.ConnectionInfo;
import de.tudarmstadt.yajs.lib.MalformedMessage;
import de.tudarmstadt.yajs.lib.fsm.ClientFSMHelper;
import java.util.HashSet;
import java.util.StringTokenizer;

/**
 * @author  markus  TODO To change the template for this generated type comment go to  Window - Preferences - Java - Code Style - Code Templates
 */
public class ReceiveLoginWelcome implements ClientAction {

	private CompleteLogin onHeartbeat;
	
	/**
	 * 
	 */
	public ReceiveLoginWelcome(CompleteLogin onHeartbeat) {
		super();
		this.onHeartbeat = onHeartbeat;
	}

	/* (non-Javadoc)
	 * @see de.tudarmstadt.yajs.lib.Action#perform(de.tudarmstadt.yajs.lib.ClientHelper, de.tudarmstadt.yajs.lib.FSMHelper, java.lang.String)
	 */
	public void perform(ClientHelper client, ClientFSMHelper fsm, String s) throws MalformedMessage {
		StringTokenizer st = new StringTokenizer(s, "\n");
		if(st.countTokens() != 3) throw new MalformedMessage(s);
		String msg, loginname, flags;
		msg = st.nextToken();
		loginname = st.nextToken();
		flags = st.nextToken();
		
		HashSet flagset = new HashSet();
		StringTokenizer fst = new StringTokenizer(flags);
		while(fst.hasMoreTokens())
		{
			flagset.add(fst.nextToken());
		}
		
		ConnectionInfo ci = new ConnectionInfo(loginname, flagset);
		client.setConnectionInfo(ci);
		
		fsm.unregisterAction(LOGIN_WELCOME);
		fsm.registerAction(LOGIN_WELCOME, new RejectUnexpected());
		
		// OK... we got the login... so everything is okay...
		onHeartbeat.setSuccess(true);
		
		// On autoconfig messages, collect all information
		fsm.registerAction(AUTOCONFIG, new CollectAutoConfig());
		
		// Start the "real" protocol
		fsm.initializeProtocol();
	}
}
