/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on Apr 5, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.tudarmstadt.yajs.lib.fsm.actions;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;

import de.tudarmstadt.yajs.lib.MalformedMessage;
import de.tudarmstadt.yajs.lib.UnexpectedMessage;
import de.tudarmstadt.yajs.lib.fsm.ClientFSMHelper;
import de.tudarmstadt.yajs.lib.judge.JudgeHelper;

/**
 * @author markus
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ReceiveSubmission implements JudgeAction {

	/* (non-Javadoc)
	 * @see de.tudarmstadt.yajs.lib.fsm.actions.JudgeAction#perform(de.tudarmstadt.yajs.lib.judge.JudgeHelper, de.tudarmstadt.yajs.lib.fsm.ClientFSMHelper, java.lang.String)
	 */
	public void perform(JudgeHelper judge, ClientFSMHelper fsm, String msg) throws UnexpectedMessage, MalformedMessage {
		BufferedReader reader = new BufferedReader( new StringReader(msg) );
		String code;
		long submissionnr;
		String lockstatus;
		try {
			code = reader.readLine();
			submissionnr = Long.parseLong(reader.readLine());
			lockstatus = reader.readLine();
		} catch (IOException e) {
			throw new MalformedMessage("Malformed submission_source message:\n" + msg);
		} catch (NumberFormatException e) {
			throw new MalformedMessage("Malformed submission number:\n" + msg);
		}
		
		if(lockstatus.equals("success"))
		{
			try {

				StringBuffer source = new StringBuffer();
				char[] buf = new char[4096];
				int len = 0;
				while((len = reader.read(buf, 0, buf.length)) >= 0)
				{
					source.append(buf, 0, len);
				}
				judge.signalSubmissionLocked(submissionnr, source);
			} catch (IOException e1) {
				throw new MalformedMessage("IO Error while reading code:\n" + msg);
			}
		} else {
			judge.signalSubmissionNotLockable(submissionnr);
		}
	}
}
