/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 06.05.2005
 *
 */
package de.tudarmstadt.yajs.lib.fsm.actions;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;

import de.tudarmstadt.yajs.lib.ClientHelper;
import de.tudarmstadt.yajs.lib.MalformedMessage;
import de.tudarmstadt.yajs.lib.UnexpectedMessage;
import de.tudarmstadt.yajs.lib.fsm.ClientFSMHelper;

/**
 * @author markus
 *
 */
public class UpdateScoreboard implements ClientAction {

	public void perform(ClientHelper client, ClientFSMHelper fsm, String msg) throws UnexpectedMessage, MalformedMessage {
		BufferedReader reader = new BufferedReader(new StringReader(msg));
		try {
			reader.readLine();
			char board[] = new char[msg.length()];
			int len = reader.read(board, 0, board.length);
			String scoreboard = new String(board, 0, len);
			if(!scoreboard.trim().equals(""))
				client.signalScoreboardUpdate(scoreboard);
		} catch (IOException e) {
			// should never happen
			e.printStackTrace();
			System.err.println("!!! THIS SHOULD NEVER HAPPEN !!!");
		}
	}

}
