/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 14.03.2005
 *
 */
package de.tudarmstadt.yajs.lib.judge;

import de.tudarmstadt.yajs.lib.ClarificationAnswerState;
import de.tudarmstadt.yajs.lib.ClientHelper;
import de.tudarmstadt.yajs.lib.JudgeResult;

/**
 * @author markus
 *
 */
public interface JudgeHelper extends ClientHelper {

	/**
	 * @param jr
	 */
	void signalJudgementNotified(JudgeResult jr);

	/**
	 * @param jr
	 */
	void signalJudgementPolled(JudgeResult jr);

	/**
	 * @param submissionnr
	 * @param source
	 */
	void signalSubmissionLocked(long submissionnr, StringBuffer source);

	/**
	 * @param submissionnr
	 */
	void signalSubmissionNotLockable(long submissionnr);

	/**
	 * @param nr
	 */
	void signalClarificationNotLockable(long nr);

	/**
	 * @param nr
	 */
	void signalClarificationLocked(long nr);

	/**
	 * @param clarificationnr
	 * @param questioner
	 * @param request
	 */
	void signalClarificationRequest(long clarificationnr, String questioner, String problemid, String question, long time);

	/**
	 * @param requestnr
	 * @param judgename
	 * @param state
	 * @param time
	 * @param b
	 * @param lock
	 */
	void signalClarificationAnswer(long requestnr, String judgename, ClarificationAnswerState state, long time, boolean b, String lock, String answer);

	/**
	 * @param status
	 */
	void signalServerStatusUpdate(String status);

}
