/*
 * Copyright 2005 Markus Moll
 *
 * This file is part of Refefree.
 *
 * Refefree is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Refefree is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
/*
 * Created on 30.03.2005
 *
 */
package de.tudarmstadt.yajs.tester;

import java.util.EventListener;

/** The listener used for handling the test completed event.
 * @author markus
 *
 */
public interface TestCompletedEventListener extends EventListener {

	/** The test was successfully completed.
	 * @param re The event containing more information.
	 */
	void testCompleted(TestCompletedEvent re);

	/** The test was interrupted unexpectedly, due to some error.
	 * @param error The error.
	 */
	void testInterrupted(String error);

}
